#
# spec file for package lsh (Version 1.5.2)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  gmp gperf guile readline readline-devel slib x-devel-packages
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs autoconf automake binutils cracklib fontconfig fontconfig-devel gcc gdbm gettext gmp gperf guile libtool perl readline-devel rpm slib

Name:         lsh
Version:      1.5.2
Release:      51
%define oopver	0.9
License:      GPL
Group:        Productivity/Networking/SSH
#Provides:     
Autoreqprov:  on
Summary:      The GNU implementation of the secure shell protocol
Source:       ftp://ftp.gnupg.org/gcrypt/lsh/lsh-%{version}.tar.gz
Source1:      ftp://ftp.gnupg.org/gcrypt/lsh/lsh-%{version}.tar.gz.asc
#Source9:	ftp://ftp.gnupg.org/gcrypt/contrib/idea.c
Source2:      rc.lshd
Source4:      sysconfig.lshd
Source6:      lshd.pamd
Source11:     http://download.liboop.org/liboop-%{oopver}.tar.bz2
Patch:        lsh-%{version}.diff
Patch2:       lsh-%{version}-nospool.diff
Patch3:       lsh-%{version}-pamlshd.diff
Patch4:       lsh-%{version}-random.diff
Patch5:       lsh-%{version}-disable-checks.diff
Patch6:       lsh-abort-on-alloc-fail.diff
URL:          http://www.gnupg.org/
Prefix:       /usr
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%if %suse_version > 810
PreReq:       %fillup_prereq %insserv_prereq %install_info_prereq
%else
%if %suse_version > 800
PreReq:       %fillup_prereq %insserv_prereq
%endif
%endif

%description
Similar to openssh, this is a free implementation of the secure shell 2
protocol. The package consists of the lshd daemon accepting connections
to port 22 (ssh), the lsh client and tools for key management.

lsh is compiled without support for the IDEA algorithm required by ssh1
clients. The reason is that IDEA is encumbered by patents, and may only
be used free of charge in certain strictly non-commercial environments.

lsh however can be installed along with (open)ssh and supports fallback
to a opensshd resp. sshd1 daemon for such connections.

Documentation can be found in /usr/share/doc/packages/lsh/

Note: This package is still under development. If you want high
security and stability, better use openssh for now!



Authors:
--------
    Niels Mller <nisse@lysator.liu.se>
    ... and many others.

%package devel
Summary:      Cryptographic library libnettle (from lsh)
Group:        Productivity/Networking/SSH
Provides:     lsh:/usr/%{_lib}/libnettle.a
Autoreqprov:  on
Requires:     %name = %version
%if %suse_version > 810
PreReq:       %install_info_prereq
%endif

%description devel
Similar to openssh, lsh is a free implementation of the secure shell 2
protocol. The package consists of the lshd daemon accepting connections
to port 22 (ssh), the lsh client and tools for key management.

The lsh-devel package contains the cryptographic library Nettle.

Nettle is a cryptographic library that is designed to fit easily in
more or less any context: In crypto toolkits for object-oriented
languages (C++, Python, Pike, ...), in applications like LSH or GNUPG,
or even in kernel space. In most contexts, you need more than the basic
cryptographic algorithms, you also need some way to keep track of
available algorithms, their properties and variants. You often have
some algorithm selection process, often dictated by a protocol you want
to implement.



Authors:
--------
    Niels Mller <nisse@lysator.liu.se>
    ... and many others.

%package -n liboop
Summary:      Event loop handling library (used by lsh)
Group:        SuSE internal
License:      LGPL
URL:          http://www.liboop.org/

%description -n liboop
Liboop is a low-level event loop management library for POSIX-based
operating systems. It supports the development of modular, multiplexed
applications which may respond to events from several sources. It
replaces the "select() loop" and allows the registration of event
handlers for file and network I/O, timers and signals. Since processes
use these mechanisms for almost all external communication, liboop can
be used as the basis for almost any application.



Authors:
--------
    Dan Egnor <egnor@ofb.net>

SuSE series: suse

%prep
%setup -b11 
%patch -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
#cp -p $RPM_SOURCE_DIR/idea.c ${name}-%{version}/src
chown 0:0 -R *
%{?suse_update_config}
cd ../liboop-%{oopver}
%{?suse_update_config}

%build
#autoreconf
cd ../liboop-%{oopver}
#autoreconf
CFLAGS="$RPM_OPT_FLAGS" ./configure --disable-shared --prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} --sysconfdir=/etc --localstatedir=/var --libdir=%{_libdir}
make
# We install into BuildRoot and append that to the search path for lsh.
make install DESTDIR=$RPM_BUILD_ROOT
cd ../lsh-%{version}
CFLAGS="$RPM_OPT_FLAGS" ./configure --with-sshd1=/usr/sbin/sshd1 \
	--prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} \
	--sysconfdir=/etc --localstatedir=/var --sharedstatedir=/var \
	--libdir=%{_libdir} \
	--with-include-path=$RPM_BUILD_ROOT/usr/include \
	--with-lib-path=$RPM_BUILD_ROOT/usr/%{_lib}
make
make check

%install
make install DESTDIR=$RPM_BUILD_ROOT
install -o root -g root -m 0755 src/lcp $RPM_BUILD_ROOT/usr/bin/
install -d -o root -g root -m 0750 $RPM_BUILD_ROOT/etc/init.d/
install -d -o root -g root -m 0750 $RPM_BUILD_ROOT/var/adm/fillup-templates
install -o root -g root -m 750 $RPM_SOURCE_DIR/rc.lshd $RPM_BUILD_ROOT/etc/init.d/lshd
install -o root -g root -m 640 $RPM_SOURCE_DIR/sysconfig.lshd $RPM_BUILD_ROOT/var/adm/fillup-templates/
ln -sf ../../etc/init.d/lshd $RPM_BUILD_ROOT/usr/sbin/rclshd
# The state dir
mkdir -p $RPM_BUILD_ROOT/var/lib/lsh
# The keys
#touch $RPM_BUILD_ROOT/etc/lsh_host_key
#chmod 600 $RPM_BUILD_ROOT/etc/lsh_host_key
#touch $RPM_BUILD_ROOT/etc/lsh_host_key.pub
# PAM
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -o root -g root -m 644 %{S:6} $RPM_BUILD_ROOT/etc/pam.d/lshd

%files
%defattr(-,root,root)
%dir /var/lib/lsh
#%ghost %attr(0600,root,root) /etc/lsh_host_key
#%ghost %attr(0644,root,root) /etc/lsh_host_key.pub
/usr/bin/lsh
/usr/bin/lshg
/usr/bin/lsh-authorize
/usr/bin/lsh-decrypt-key
/usr/bin/lsh-decode-key
/usr/bin/lsh-export-key
/usr/bin/lsh-keygen
/usr/bin/lsh-make-seed
/usr/bin/lsh-upgrade
/usr/bin/lsh-upgrade-key
/usr/bin/lsh-writekey
/usr/bin/sexp-conv
/usr/bin/srp-gen
/usr/bin/ssh-conv
/usr/bin/lcp
/usr/bin/lsftp
/usr/sbin/lshd
#/usr/sbin/lsh_proxy
/usr/sbin/sftp-server
/usr/sbin/lsh-execuv
/usr/sbin/lsh-pam-checkpw
%{_infodir}/lsh.info.gz
# some maniac removed the manpages from -1.5.2 ...
%doc README NEWS COPYING ANNOUNCE AUTHORS ChangeLog FAQ distribution-key.gpg
%doc doc/NOTES doc/TASKLIST doc/TODO doc/HACKING doc/*.txt
#/usr/share/locale/*/LC_MESSAGES/lsh.mo
%config /etc/pam.d/lshd
/etc/init.d/lshd
/usr/sbin/rclshd
/var/adm/fillup-templates/sysconfig.lshd

%files devel
%defattr(-,root,root)
/usr/%{_lib}/libnettle.a
/usr/include/nettle
%{_infodir}/nettle.info.gz
%{_infodir}/nettle.info-?.gz
%doc src/nettle/README src/nettle/NEWS src/nettle/TODO src/nettle/AUTHORS src/nettle/COPYING

%files -n liboop
%defattr(-,root,root)
/usr/include/oop*.h
/usr/%{_lib}/liboop*
%doc ../liboop-%{oopver}/COPYING

%post
# Create startup symlinks (LSB)
%{fillup_and_insserv -n -s lshd lshd START_LSHD}
%install_info --info-dir=%{_infodir} %{_infodir}/lsh.info.gz

%post devel
%install_info --info-dir=%{_infodir} %{_infodir}/nettle.info.gz

%postun
%insserv_cleanup
%install_info_delete --info-dir=%{_infodir} %{_infodir}/lsh.info.gz

%postun devel
%install_info_delete --info-dir=%{_infodir} %{_infodir}/nettle.info.gz

%clean
test ! -z "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT
#rm -rf $RPM_BUILD_DIR/liboop-%{oopver}
#rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%changelog -n lsh
* Mon Sep 29 2003 - garloff@suse.de
- Add patch to properly deal with allocation failure. #31418.
  This potentially constitutes in a remotely exploitable
  vulnerability.
* Fri Aug 22 2003 - mmj@suse.de
- Add sysconfig metadata [#28895]
* Sat Jul 19 2003 - garloff@suse.de
- The manpages have apparently been removed from the package.
  (The XXXX doing it did not even document this in the NEWS
  file.)
- lsh_proxy has left as well.
* Sat Jul 19 2003 - garloff@suse.de
- Build fix: chown uid:gid instead of uid.gid
- Update to lsh-1.5.2:
  * Encrypted private keys fixes
  * \r~? lists available esc sequences (client)
  * multiple --interface options possible in server
  * parallel connections to machines with multiple IP addresses
  * fix fd leak
  * portability fixes
- Update to lsg-1.5.1:
  * spki draft implemented, introducing an incompatible change to
  key format. Use lsh-upgrade to convert (known-hosts ->
  host-acls)
  * IPv6 bug fixed
  * lshd sets ulimit -n unlimited; setting ulimits or environment
  in PAM will not work with lshd (use /etc/profile or similar).
  * lshg uses options from LSHFLAGS and LSHGFLAGS env vars. Can
  be overriden on cmd-line, of course
* Thu Jun 05 2003 - ro@suse.de
- remove umb-scheme from neededforbuild
* Thu Apr 24 2003 - ro@suse.de
- fix install_info --delete call and move from preun to postun
* Sun Feb 09 2003 - garloff@suse.de
- Update to liboop-0.9:
  * memleak in creation/destruction of system event source fixed.
  * signal handling robustness improved.
  * protability improvements.
- Add syscondifg Metadata. [bug #22656]
- Use %%install_info macros. [bugs #23436, 23438]
- Include all nettle info files in lsh-devel package.
* Wed Dec 11 2002 - garloff@suse.de
- Upgrade to lsh-1.5:
  * X11 forwarding supported on server side as well now
  * IPv6 support can be compiled on non-supp. compile platforms
  * bugfixes (setsid, ...)
* Tue Sep 03 2002 - schwab@suse.de
- Prefer /dev/urandom over /dev/random to avoid blocking if system runs
  out of entropy.
* Mon Aug 19 2002 - garloff@suse.de
- Add %%insserv_prereq and %%fillup_prereq (bug #17962)
* Fri Aug 09 2002 - garloff@suse.de
- Add dependency on main package to -devel package
* Tue Jul 30 2002 - garloff@suse.de
- Update to lsh-1.4.2: (bug-fix release)
  * Fixed minor bug in bubble-babble key display.
  * Fixed support for encrypted private keys.
  * Tweaks to the handling of disabled accounts, and shadow
  passwords. (SuSE enabled PAM, so ignore these ...)
  * Disabled the "I/O error" message that was printed to the
  server log every time a session logged out.
  * Improved the server's EOF-handling on pty:s.
* Sun Jul 28 2002 - kukuk@suse.de
- remove libz and pam-devel from neededforbuild
* Wed Jul 03 2002 - garloff@suse.de
- raise(SIGTERM) instead of exit(1) for failed do_listen().
- Better initscipt handling. Support both --daemonic and non-
  daemonic mode.
* Wed Jul 03 2002 - garloff@suse.de
- exit(1) on failure in do_listen().
- Make startup script wait 1/4 s and check for presence of lshd
  to return proper status.
- Don't use traditional unix passwd if password-helper is specified
  (so PAM is effective now).
- pass -damonic and --password-helper=/usr/sbin/lsh-pam-checkpw
  to lshd by default.
* Wed Jul 03 2002 - garloff@suse.de
- Use "lshd" instead of other for PAM authgentication and put
  pam.d/lshd config file there (copy from openssh).
* Wed Jul 03 2002 - garloff@suse.de
- Split off -devel package which contains libnettle.
- Split random number seed and host key generation in initscript.
* Wed Jul 03 2002 - garloff@suse.de
- Add %%dir /var/lib/lsh to file list.
- Fix lsh_host_key creation.
* Wed Jul 03 2002 - garloff@suse.de
- Build subpackage from liboop.
* Wed Jul 03 2002 - garloff@suse.de
- Init script fixes.
- lib64 fixes.
* Wed Jul 03 2002 - garloff@suse.de
- Update to lsh-1.4.1:
  * Set SSH_CLIENT/SSH_TTY environment vars
  * TCP wrapper support (enabled) (P. Skld)
  * lsh/lshg gateway could produce slightly oversized packets
  * Improved key reexchange handling (once an hour)
  * aes256-cbc is default cipher now
  * SIGHUP: Close listening port, wait for existing connections
  to be closed before exiting.
  * Handshake (authentication) timeout.
  * Helper program to allow PAM password (P. Skld).
  * utmp logging
  * --server option for lsh-keygen and lsh-writekey
  * lsftp included
  * option --subsystem to start subsystems such as sftp
  * New random generator (Yarrow-256)
* Mon Jan 14 2002 - garloff@suse.de
- Add missing mpz_init calls to make_rsa_signer
- Add slib to build requirements
- Switch to new sysconfig handling
* Sat Jan 12 2002 - garloff@suse.de
- Include needed liboop and compile statically (for now)
- Install some more docu files
* Sat Jan 12 2002 - garloff@suse.de
- Update to lsh-1.3.5:
  * Fixed window change handling in lshd.
  * Replaced the io-backend code. Now uses liboop.
  * Uses nettle's implementations of cbc and des3 chaining.
* Fri Oct 26 2001 - garloff@suse.de
- Avoid triggering guile regeneration of .x file to fix build
  on iA64.
* Fri Oct 26 2001 - garloff@suse.de
- Compile fix for missing UINT64 decl (triggered on iA64).
* Thu Oct 11 2001 - ro@suse.de
- fix xauth.c to compile
* Tue Sep 11 2001 - garloff@suse.de
- Fix file list
- Fix init script (compliance with LSB)
* Mon Sep 10 2001 - garloff@suse.de
- Upgrades to lsh-1.3.4:
  * Suspend works
  * AES & SRP support improvements
  * X11 forwarding
- Upgrades to lsh-1.3.0:
  * Infrastructure changes
  * TSTP signal handling
- Upgrades to lsh-1.2: (1.1.1--1.2.0)
  * Gateway mode
  * CVS workarounds (avoid non-blocking mode for stdio fds)
  * encrypted private keys
  * RSA key support (incl. OpenSSH style)
  * scsh support
  * lcp (not installed by default)
  * Bugfixes & Cleanups
- Upgrades to lsh-1.1: (1.0.5--1.1.0)
  * Many new options
  * Many many bugfixes
  * Rijndael, Serpent algos
  * SPKI stuff
  * Kerberos support (experimental)
* Tue Sep 19 2000 - garloff@suse.de
- Upgrade to lsh-1.0.4
- Fixed manpage names (lsh-keygen, lsh-writekey)
* Sat Jul 08 2000 - garloff@suse.de
- Initial creation of lsh-1.0 package
- Added startup script and config via rc.config
- Use /usr/sbin/sshd as ssh1d path
